/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getDisplayableValuesOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getDisplayableValuesOperationDispatcher. It contains of all the generic methods
    for getDisplayableValuesOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getDisplayableValuesOperationDispatcher_HXX
#define getDisplayableValuesOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getDisplayableValuesOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getDisplayableValuesOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getDisplayableValuesOperationDispatcher();
        virtual ~getDisplayableValuesOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        //virtual void askDispatches(bool & condDispatch, bool& preDispatch, bool & baseDispatch, bool& postDispatch );

        void getDisplayableValuesPreConditions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues ) const;
        void getDisplayableValuesPreActions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues ) const;
        void getDisplayableValuesBaseAction( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues ) const;
        void getDisplayableValuesPostActions( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues ) const;

        // Project 011450 changes
        void getDisplayableValuesPreConditions( METHOD_message_t*  msgData, int* num, char*** value ) const;
        void getDisplayableValuesPreActions( METHOD_message_t*  msgData, int* num, char*** value ) const;
        void getDisplayableValuesBaseAction( METHOD_message_t*  msgData, int* num, char*** value ) const;
        void getDisplayableValuesPostActions( METHOD_message_t*  msgData, int* num, char*** value ) const;

        void getDisplayableValues( const Teamcenter::BusinessObject* obj, std::vector<std::string>& stringValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getDisplayableValuesOperationDispatcher_HXX
